Introduce CI gating

This commit is contained in:
Edjunior Machado 2021-04-09 18:04:11 +02:00 committed by submachine
parent 9416cd2848
commit e10f618426
7 changed files with 188 additions and 0 deletions

1
.fmf/version Normal file
View File

@ -0,0 +1 @@
1

19
gating.yaml Normal file
View File

@ -0,0 +1,19 @@
--- !Policy
product_versions:
- fedora-*
decision_context: bodhi_update_push_stable
subject_type: koji_build
rules:
- !PassingTestCaseRule {test_case_name: fedora-ci.koji-build.tier0.functional}
--- !Policy
product_versions:
- rhel-8
decision_context: osci_compose_gate
rules:
- !PassingTestCaseRule {test_case_name: baseos-ci.brew-build.tier1.functional}
--- !Policy
product_versions:
- rhel-9
decision_context: osci_compose_gate
rules:
- !PassingTestCaseRule {test_case_name: baseos-ci.brew-build.tier1.functional}

6
plans/ci.fmf Normal file
View File

@ -0,0 +1,6 @@
summary: CI Gating Plan
discover:
how: fmf
directory: tests
execute:
how: beakerlib

View File

@ -0,0 +1,63 @@
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
# Makefile of /tools/byacc/Regression/upstream-testsuite
# Description: Runs the upstream byacc testsuite.
# Author: Arjun Shankar <ashankar@redhat.com>
#
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
# Copyright (c) 2016 Red Hat, Inc.
#
# This program is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation, either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see http://www.gnu.org/licenses/.
#
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
export TEST=/tools/byacc/Regression/upstream-testsuite
export TESTVERSION=1.0
BUILT_FILES=
FILES=$(METADATA) runtest.sh Makefile PURPOSE
.PHONY: all install download clean
run: $(FILES) build
./runtest.sh
build: $(BUILT_FILES)
test -x runtest.sh || chmod a+x runtest.sh
clean:
rm -f *~ $(BUILT_FILES)
include /usr/share/rhts/lib/rhts-make.include
$(METADATA): Makefile
@echo "Owner: Arjun Shankar <ashankar@redhat.com>" > $(METADATA)
@echo "Name: $(TEST)" >> $(METADATA)
@echo "TestVersion: $(TESTVERSION)" >> $(METADATA)
@echo "Path: $(TEST_DIR)" >> $(METADATA)
@echo "Description: Runs the upstream byacc testsuite." >> $(METADATA)
@echo "Type: Regression" >> $(METADATA)
@echo "TestTime: 30m" >> $(METADATA)
@echo "RunFor: byacc" >> $(METADATA)
@echo "Requires: byacc gcc glibc-devel glibc-headers make sed rpm-build yum-utils" >> $(METADATA)
@echo "Priority: Normal" >> $(METADATA)
@echo "License: GPLv2+" >> $(METADATA)
@echo "Confidential: no" >> $(METADATA)
@echo "Destructive: no" >> $(METADATA)
@echo "Releases: -RHEL4 -RHELClient5 -RHELServer5" >> $(METADATA)
rhts-lint $(METADATA)

View File

@ -0,0 +1,3 @@
PURPOSE of /tools/byacc/Regression/upstream-testsuite
Description: Runs the upstream byacc testsuite.
Author: Arjun Shankar <ashankar@redhat.com>

View File

@ -0,0 +1,19 @@
summary: Runs the upstream byacc testsuite.
description: ''
contact: Arjun Shankar <ashankar@redhat.com>
component:
- byacc
test: ./runtest.sh
framework: beakerlib
recommend:
- byacc
- gcc
- glibc-devel
- glibc-headers
- make
- sed
- rpm-build
- yum-utils
duration: 30m
extra-summary: /tools/byacc/Regression/upstream-testsuite
extra-task: /tools/byacc/Regression/upstream-testsuite

View File

@ -0,0 +1,77 @@
#!/bin/bash
# vim: dict+=/usr/share/beakerlib/dictionary.vim cpt=.,w,b,u,t,i,k
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
# runtest.sh of /tools/byacc/Regression/upstream-testsuite
# Description: Runs the upstream byacc testsuite.
# Author: Arjun Shankar <ashankar@redhat.com>
#
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
# Copyright (c) 2016 Red Hat, Inc.
#
# This program is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation, either version 2 of
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see http://www.gnu.org/licenses/.
#
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Include Beaker environment
. /usr/share/beakerlib/beakerlib.sh || exit 1
PACKAGE="byacc"
REQUIRES="byacc gcc glibc-devel make sed rpm-build"
MY_USER="byacctestuser"
DOTEST=$(mktemp)
cat > $DOTEST <<-EOF
#!/bin/bash
set -xe
_BASEDIR=\$1
_TMP=\$(mktemp -d)
rpm --define="_topdir \$_TMP" -Uvh \$_BASEDIR/byacc*.src.rpm
rpmbuild --define="_topdir \$_TMP" -bc \$_TMP/SPECS/byacc.spec
pushd \$_TMP/BUILD/byacc-*
# In case the test fails, the existcode of make check is non-zero.
# In such case this script fails too because of set -e above.
make check
popd
set -xe
EOF
rlJournalStart
rlPhaseStartSetup
rlRun "useradd $MY_USER" 0,9
rlRun "chown $MY_USER:$MY_USER $DOTEST"
rlAssertRpm --all
rlRun "TMP=\$(mktemp -d)"
rlRun "chmod a+rx $TMP"
rlRun "pushd $TMP"
if rlIsRHEL; then
rlFetchSrcForInstalled $PACKAGE
else
yumdownloader --source $PACKAGE
fi
rlRun "chmod a+r byacc*.src.rpm"
rlPhaseEnd
rlPhaseStartTest
rlRun "su - $MY_USER -c 'bash $DOTEST $(pwd)'"
rlPhaseEnd
rlPhaseStartCleanup
rlRun "popd"
rlRun "rm -rf $TMP $DOTEST"
rlRun "userdel -f $MY_USER"
rlPhaseEnd
rlJournalPrintText
rlJournalEnd